'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _path = require('path');

var _path2 = _interopRequireDefault(_path);

var _yeomanGenerator = require('yeoman-generator');

var _yeomanGenerator2 = _interopRequireDefault(_yeomanGenerator);

var _branchFinder = require('./branch-finder');

var _branchFinder2 = _interopRequireDefault(_branchFinder);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

class BaseGenerator extends _yeomanGenerator2.default {

  constructor(...args) {
    super(...args);
  }

  _copyOp(srcPath, tgtPath, transFns) {
    let copyOptions = {};
    if (transFns && transFns.length) {
      copyOptions.process = function (contents) {
        let s = contents.toString();
        for (let i = 0; i < transFns.length; i++) {
          let transFn = transFns[i];
          s = transFn(s);
        }
        return s;
      };
    }
    this.fs.copy(srcPath, tgtPath, copyOptions);
  }

  _branchCopy(opt) {
    const source = opt.source;
    const tgtBase = opt.target || '';
    const transformers = opt.transformers || [];
    const pattern = opt.pattern || '**/*';
    const branches = opt.branches || {};
    const srcBase = this.sourceRoot();
    let _options = {
      pattern: _path2.default.join(source, pattern),
      tgtRelalative: source,
      branches: branches,
      transformers: transformers,
      op: this._copyOp.bind(this)
    };
    let bf = new _branchFinder2.default(srcBase, tgtBase, _options);
    bf.run();
  }

}

exports.default = BaseGenerator;